@echo off

:	The build.bat file generates the GTAP5 dataset 
:	(gtap001.gdx) from the GTAP5.4 dataset.
:
:	The GTAP data (gsddat.har) needs to be placed in ..\data\
:
:	For more information, see readme.txt in this archive or
:	http://debreu.colorado.edu/gtap/gtapgams.html
:
:	Thomas Rutherford and Sergey Paltsev
:	rutherford@colorado.edu
:	May 2001

if exist ..\data\gtap001.gdx	goto aggr
if exist ..\data\gtap.gdx	goto filter
if exist ..\data\gsddat.har	goto start

echo	Error: cannot find ..\data\gsddat.har
echo.
echo	You need to contact GTAP to obtain this file.
echo.
echo	For more information see README.TXT
echo.
goto end

:start
echo.
echo.
echo	Ready to convert gsddat.har into ..\data\gsddat.gdx
echo	using Mark Horridge's program har2gdx.
pause
har2gdx ..\data\gsddat.har ..\data\gsddat.gdx
echo.
echo.
echo	Ready to use GAMS to relabel, scale, and create ..\data\gtap.gdx:
pause
call gams relabel

:filter
echo.
echo.
echo	Ready to use GAMS to filter, recalibrate, and create gtap001.gdx:
echo.
pause
echo	$setglobal tolerance 001  >filter.inc

call gams filter
echo.
echo.
echo	The GTAPinGAMS dataset is now in ..\data\gtap001.gdx
echo.	
pause

:aggr
echo.
echo.
echo	Will now aggregate ..\data\gtap001.gdx to produce ..\data\gtap5_small.gdx
echo.	
pause
gams gtapaggr --ds=gtap5_small

:model
cd ..
cd models
echo.
echo	Now connected to the models directory.
echo.
echo	Will now run an illustrative MPSGE model (MRTMGE)
echo.	
pause
call gams mrtmge
echo.
echo.
echo	Will now run a consistency test of the NLP, CNS, MCP and MGE formulations:
echo.	
pause
call gams mrttest
cd..
cd build
goto end

:message
echo.
echo	You already have the GTAPinGAMS dataset.
echo.	
echo	If you want to rebuild it, delete the file GTAP001.GDX
echo	from the DATA subdirectory, and run BUILD.BAT again.
echo.

:end
