@echo off
:	The energy.bat file generates the dataset (energy5.zip) 
:	comparable to GTAP-EG model. The dataset is build based
:	on the GTAP version 5 (pre-release#3).
:
:	The batch file starts from the GTAPinGAMS dataset. If the file  
:	GTAP001.ZIP does not exist, it requires the BUILD routine.
:
:	Thomas Rutherford and Sergey Paltsev
:	rutherford@colorado.edu
:	May 2001


if not exist ..\data\gtap001.zip call build

:energy
echo.
echo	Building the energy database
echo.


:pause
call gtapaggr iea

: The program ene.gms adds IEA data, calculates energy statistics, and converts the dataset
: into the GTAP-EG format 
: source file - iea.zip
: target file - gtapiea.zip

:pause
call gams ene

echo	Relabel the energy commodities, translating gtapiea.zip to aspen5.zip:

if exist ..\defines\aspen5.map goto foundaspen

echo	Cannot find ..\defines\aspen5.map
echo	The files aspen5.set and aspen5.map must be written by hand.
:pause
goto end

:foundaspen
:pause
call gtapaggr aspen5



echo	Aggregate to 13x8, incude energy projections and create aspen5_small.zip

if exist ..\defines\aspen5_small.map goto foundsmall

echo	Cannot find ..\defines\aspen5_small.map
echo	The files aspen5_small.set and aspen5_small.map must be written by hand.
:pause
goto end

:foundsmall

echo	Will aggregate to aspen5_small:

pause
call gtapaggr aspen5_small

:model

echo	Running an illustrative model:
pause

cd ..
cd models
call gams gtap-eg
cd ..
cd build

:end

