$TITLE  GTAPinGAMS -- Static Multiregional Core Model in MPSGE Syntax

$setglobal dataset aspen5_small

*	Note:

*		This is the model implemented in MPSGE.

*		This implementation accomodates both constant-elasticity of
*		transformation between production for domestic and export
*		markets (eta < +INF), and perfect substitution between 
*		those markets (eta=+INF).

*		Variables, equations and GAMS keywords are in UPPER case.
*		Sets and parameters are in lower case.

*	Read the dataset using the standard routine:

$IF EXIST dataset $INCLUDE dataset
$INCLUDE ..\inclib\mrtdata

SCALAR
	eta	Elasticity of transformation - domestic vs. exports	/ 8 /,
	esubdm	Elasticity of substitution - domestic vs. imports	/ 4 /,
	esubmm  Elasticity of substitution - imports			/ 8 /;

execute_unload 'mge.gdx', i, r, d, f, num, eta, esubdm, esubmm, 
	vom, vim, va, vdm, vxm, evoa, vafm, vfm, vd, vm, 
	vtwr, vg, vgm, vp, vpm, vt, vst, evoa, vb, vi, vxmd, 
	pf0, pmx0, pmt0, pg0, pc0,
	ty, ti, tf, tx, tm, tg, tp;
