$model:demo

$sectors:
  y(s)              ! production
  c                 ! aggregate consumption
  va(s)             ! value added
  g                 ! government expenditure

$commodities:
  p(o)              ! price of commodity
  pc                ! price of aggregate consumption
  pg                ! price of a unit of government output
  pva(s)            ! price index for value added
  pf(f)             ! price of primary factor

$consumers:
  ra                ! representative agent income
  gov               ! government income

$auxiliary:
  upl               ! unemployment index

$prod:y(s)          t:etrn(s)
  o:p(o)            q:supply(s,o)       p:top_y(s,o)        a:gov     t:to_y(s,o)
  i:p(o)            q:interm(o,s)
  i:pva(s)          q:(sum(f, factor(f,s)))

$prod:va(s)         s:esub(s)
  o:pva(s)          q:(sum(f, factor(f,s)))
  i:pf(f)           q:factor(f,s)

$prod:c             s:1.0
  o:pc              q:(sum(o, demand(o)))
  i:p(o)            q:demand(o)

$prod:g
  o:pg              q:(sum(o, govdem(o)))
  i:p(o)            q:govdem(o)

$demand:ra
  d:pc
  e:pf(f)           q:endow(f)
! Our program crashes here - "error in numeric field"
!  e:pf("lab")       q:-endow("lab")     r:upl

$demand:gov
  d:pg

! Our program gives error - no colon in line below $constraint:
! $constraint:upl
!  pf("lab") / pc =e= 1;

$report:
  v:r_supply(s,o)   o:p(o)              prod:y(s)
  v:r_cons(o)       i:p(o)              prod:c

