program mge2xx

	use mpsge
	use mpsGP
	use mpsGMS

        implicit none

        character (len=255) :: fname, fnameroot
	integer ios, n1, astat   ! KP
	logical :: InputFileExists, openok, InputHarFileExists
	character :: ch1
	logical :: FoundANest, HaveConvertedMGEFile, ConvertMGEIfNecessary

	character (len=1024) :: CMDLine ! KP

! For calling GEMPACK routines to find out info on a Header Array file
!       GPRCON,GPRCNI stored as common blocks to control various run-time
!	   features such as recovery from invalid input, full/brief prompts,
!          whether running from Stored-input/Command file etc.
!
	integer gprcni(50)
	common /gpruni/ gprcni
	character*128 gprcon
	common /gprun/ gprcon

	HaveConvertedMGEFile = .false.
	ConvertMGEIfNecessary = .true.

	nullify(gmsrecords)

! Initialize all error message strings  ! KP
	call InitializeMessages('all',0) ! KP

!!      Read file name and model name from the command line:

        call getcl(CMDLine)
	call ProcessCommandLine(CMDLine)

! [15/04/04] Temporarily set ConverToMGE false
	ConvertToMGE = .false.

! Temporary
!	fnameroot='basic'
!	fnameroot='demo'
!	fnameroot='demo2'
! Now expect InputFileName on command line - later may prompt for it if not there.
	if(InputFileName.ne.' ') then
	  n1 = INDEX(InputFileName,'.',back=.true.)
	  if(n1.gt.1) then
	    fnameroot = InputFileName(1:n1-1)
	  else
	    fnameroot = InputFileName
	    inquire(file=InputFileName, Exist=InputFileExists)
	    if (.not.InputFileExists) InputFileName = trim(InputFileName)//'.mge'
	  end if
	else
	  call InitializeMessages('all',0)
	  call ErrorStop('Expect input file name to be on the command line.')
	end if
	  

! KP Set values to tell what conversions want to do
! Now set from the command line

!        open(iomps,file='basic.mps')
!        open(iomps,file=trim(fnameroot)//'.mps')
	InputFileExists = .false.
	inquire(file=InputFileName, Exist=InputFileExists)

	if(.not.InputFileExists) then
	  call InitializeMessages('all',0)
	  call ErrorStop('Unable to open Input file - it does not exist')
	end if

	openok=.false.
        open(iomps,file=trim(InputFileName),status='old',err=18)
	openok=.true.
18	continue
	if(.not.openok) then
	  call InitializeMessages('all',0)
	  call ErrorStop('Unable to open Input MPSGE file')
	end if

	if(ConvertToGAMS) then   ! KP
!          open(iogms,file='basic_mps.gms')
! Delete IOGMS file if it exists
	  fname=trim(fnameroot)//'_mge.gms'
	  openok=.false.
          open(iogms,file=fname,status='old', err=22)  ! KP
	  openok=.true.
22	  continue
	  if(openok) then
	    close(unit=iotabgp, status='delete')
	  end if
! Open new file on IOGMS
	  openok=.false.
	  open(iogms,file=fname,status='new',err=23)
	  openok=.true.
23	  continue
	  if(.not.openok) then
	    call InitializeMessages('all',0)
	    call ErrorStop('Unable to open new GMS file')
	  end if
	end if

        NewMGEFileName = trim(fnameroot)//'_mge2xx.mge'

! [15/04/04] Is the next still needed?
	if(ConvertToMGE) open(iomge,file=trim(fnameroot)//'_kp.mge')

!--------------------------------------------------
! KP to get conversion to GEMPACK started
	if(ConvertToGEMPACK) then   ! KP

! Delete IOTABGP file if it exists
 	  tabfileroot=trim(fnameroot)  
	  fname=trim(tabfileroot)//'.tab'
	  openok=.false.
	  open(iotabgp,file=fname,status='old', err=24)
	  openok=.true.
24	  continue
	  if(openok) then
	    close(unit=iotabgp, status='delete')
	  end if
! Open new file on IOTABGP
	  openok=.false.
	  open(iotabgp,file=fname,status='new',err=26)
	  openok=.true.
26	  continue
	  if(.not.openok) then
	    call InitializeMessages('all',0)
	    call ErrorStop('Unable to open new TAB file')
	  end if
	  tabfilename=fname

! Delete IOCMFGP file if it exists  
! The Command file written does a homogeneity simulation
	  fname=trim(tabfileroot)//'homo.cmf'
	  openok=.false.
	  open(iocmfgp,file=fname,status='old', err=28)
	  openok=.true.
28	  continue
	  if(openok) then
	    close(unit=iocmfgp, status='delete')
	  end if
! Open new file on IOCMFGP
	  openok=.false.
	  open(iocmfgp,file=fname,status='new',err=32)
	  openok=.true.
32	  continue
	  if(.not.openok) then
	    call InitializeMessages('all',0)
	    call ErrorStop('Unable to open new Command file')
	  end if
	  cmffilename=fname

! Use HAR file info? At present, do so if corresponding .HAR file exists
	  UseHarFileInfo = .false.
	  harfilename = trim(tabfileroot)//'.har'
!	  write(*,*)'HARFILENAME=', trim(harfilename) 
	  InputHarFileExists = .false.
	  inquire(file=harfilename, Exist=InputHarFileExists)
! Temporarily suppress this
	  InputHarFileExists = .false.
	  if(InputHarFileExists) then
	    openok=.false.
	    open(iohargp,file=harfilename,status='old',form='unformatted',err=34)
	    write(*,*)'HAR file opened ok'
	    openok=.true.
34	    continue
	    if(.not.openok) then
	      call InitializeMessages('all',0)
	      call ErrorStop('Unable to open old HAR file '//trim(harfilename))
	    end if
	    UseHarFileInfo = .true.
	    ch1='?'
	    read(iohargp) ch1
	    write(*,*)'CH1=', ch1
	  end if ! if(InputHarFileExists) then

!	 End "if(ConvertToGEMPACK) then"
	end if
!--------------------------------------------------

! Return to here to reprocess converted MGE file when are converting to
!  GEMPACK and have found nests in the original MGE file.
180	continue

!      Master routine to read an MPSGE input file:
!        - Read one line at a time into a linked list for listing.
!        - Locate functions and set up pointers to the constituent records.
!        - Parse records into fields.
!
	if(log) write(*,*)'Calling readmps'
        call readmps

!      Parse all fields in the file into constituent elements:
!      - Field identifier text
!      - Identifier argument text
!      - Spanning domain text
!      - Condition text.

	if(log) write(*,*)'Calling parse'
        call parse

!       Read variables:

	if(log) write(*,*)'Calling readvar'
        call readvar

!       Add sector ids to the symbol table and verify that
!       multiple prod blocks have not be included.

        call sectors

!       Check input syntax on prod: records:

        call chkprod

!       Check input syntax on demand: records:

        call chkdemand

!       Read the nesting assignments from the $prod line:

        call readnest

!       Read production function coefficients and set up list of
!       nest elements:

        call readcoef

!--------------------------------------------------
	if(ConvertToGEMPACK) then

! Check to see if these are nests. If so, convert MGE file to one with no nests
	  call AreThereNests(FoundANest)

	  if(HaveConvertedMGEFile.and.FoundANest) then
	    call InternalErrorStop('There should be no nests now.')
	  end if

	end if ! if(ConvertToGEMPACK) then

	if(ConvertToGEMPACK .and. ConvertMGEIfNecessary) then

	  if(FoundANest) then
! Translate to a file without nests, and use that file to convert to GEMPACK

	    write(*,*)'Found a nest - converting to file with no nests'

            NewMGEFileName = trim(fnameroot)//'_mge2xx.mge'
! Open this file on unit IOMGE as a new file
	    openok=.false.
	    open(iomge,file=NewMGEFileName,status='old', err=128)
	    openok=.true.
128	    continue
	    if(openok) then
	      close(unit=iomge, status='delete')
	    end if
! Open new file on IOMGE
	    openok=.false.
	    open(iomge,file=newMGEFileName,status='new',err=132)
	    openok=.true.
132	    continue
	    if(.not.openok) then
	      call InitializeMessages('all',0)
	      call ErrorStop('Unable to open new MGE file')
	    end if

!         Generate indices for all the nests and netputs:

            call indices

	    call rewritemodel

	    write(*,*)'Finished converting to file with no nests'

! Close input file and attach to file where have rewritten the model
	    close(unit=iomps, status='keep')
	    close(unit=iomge, status='keep')
! Reopen file on unit IOMPS
	    openok=.false.
	    open(iomps,file=newMGEFileName,status='old',err=134)
	    openok=.true.
134	    continue
	    if(.not.openok) then
	      call InitializeMessages('all',0)
	      call ErrorStop('Unable to reopen new MGE file')
	    end if

! Now are ready to convert the new MGE file to TAB and CMF files
	    HaveConvertedMGEFile = .true.
	  
	  end if ! if(FoundANest) then

	end if ! if(ConvertToGEMPACK .and. ConvertMGEIfNecessary) then

! Set ConvertMGEIfNecessary false now have done any conversion which is needed
! Hence this will be false if jump back to 180
	ConvertMGEIfNecessary = .false.

	if(HaveConvertedMGEFile.and.FoundANest) then
! FoundANest will be false the second time through
! Process the modified file
	    goto 180
	end if

	if(ConvertToGEMPACK) then

!  Temporary
!	  call sectors

	  if(UseHarFileInfo) then
! Here are using routines from Release 7.0 of GEMPACK.
! Initialise things as GEMPACK programs expect
!.call	    call GPSTRT(prognv,dates,.TRUE.,.FALSE.,prname,errmes)
	    call GPSTRT('MGE2XX Version 1, April 2004','2004',.FALSE.,.FALSE.,'MGE2XX',errmes)
	    if( errmes(1:1).eq.'E') call InternalErrorStop('Error in routine GPSTRT')
! Find out how many headers (NumHeadOnHarFile) are on this file
	    call HAHMA( iohargp, NumHeadOnHarFile, errmes)
	    if( errmes(1:1).eq.'E') call InternalErrorStop('Error in routine HAHMA')
	    call GPTO1('There are %i headers on the file', ' ', NumHeadOnHarFile, errmes)
	    if( errmes(1:1).eq.'E') call InternalErrorStop('Error in routine GPTO1')
! Allocate the relevant arrays
	    allocate( HeadOnFile(NumHeadOnHarFile), HeadTypeOnFile(NumHeadOnHarFile), &
	      LongNameOnFile(NumHeadOnHarFile), &
              SizeOnFile(NumHeadOnHarFile,7), CHLENOnFile(NumHeadOnHarFile), &
	      StatusOnFile(NumHeadOnHarFile), &
              CoeffAndArgsOnFile(NumHeadOnHarFile), TPSTELOnFile(NumHeadOnHarFile), stat=astat)
	    if(astat.ne.0) call InternalErrorStop('Error allocating arrays for HA file info')
! Get info about the headers on the file
            call LSTHDS( iohargp, NumHeadOnHarFile, 'NumHeadOnHarFile', HeadOnFile, 1, n1, &
              HeadTypeOnFile, SizeOnFile, 7, LongNameOnFile, .TRUE., .TRUE., .TRUE., &
              CoeffAndArgsOnFile, TPSTELOnFile, ',', errmes)
	    if( errmes(1:1).eq.'E') call InternalErrorStop( &
		'Error in routine LSTHDS. Is the file a FUJITSU file?'// &
		'\n ** Lahey files will not work **')
	  end if ! if(UseHarFileInfo) then


! Set up GEMPACK names
	  call SetupGEMPACKNames

!	KP. Convert to GEMPACK
!	Writes TAB file and CMF file

	  call ConvertToGP

	end if ! if(ConvertToGEMPACK) then
!--------------------------------------------------

	if(ConvertToGAMS) then    ! added by KP

!         Output some tests of the input data:

          call testsym

!         Generate indices for all the nests and netputs:

          call indices

          call functions

          call buildmodel

	  call writemodel

!	 End "if(ConvertToGAMS) then"
	end if

	if(ConvertToMGE) then    ! added by TFR

!         Generate indices for all the nests and netputs:

          call indices

	  call rewritemodel

!	 End "if(ConvertToMGE) then"
	end if

        end program mge2xx
