*	Run the same scenario with all four models types and report
*	differences in equilibrium prices:

$include mrttest.inc

$call 'gams mgetest'
$call 'gams nlptest'
$call 'gams mcptest'
$call 'gams cnstest'

set solvers /mge, mcp, cns, nlp /;

$if not set dataset $set dataset gtap5_small
$include mrtdata

parameter prices /
$include mrt.sol
/;

*	Report differences from the MGE equilibrium:

prices(r,solvers) = round(prices(r,solvers) - prices(r,"mge"), 5);

file kcon /con/; put kcon;
if (sum((r,solvers), abs(prices(r,solvers))) gt 0,

	putclose /// "Differences detected in solutions -- see MRTTEST.LST."//;
	display prices;
else
	putclose /// "No difference detected in the solutions from alternative solvers."//;

);
