 $ontext
[1]        $model:taxout
[2]        
[3]        $sectors:
[4]          y(s)              ! production
[5]          u                 ! utility index
[6]          g                 ! government expenditure
[7]        
[8]        $commodities:
[9]          pd(o)             ! domestic price of commodity
[10]         pf(f)             ! price of primary factor
[11]         pu                ! price index for utility
[12]         pg                ! price of a government output unit
[13]       
[14]       $consumers:
[15]         ra                ! representative agent income
[16]         gov               ! government income
[17]       
[18]       $prod:y(s)          t:etrn(s)           va:esub(s)
[19]         o:pd(o)           q:supply(s,o)
[20]       +       a:gov          t:bto(s,o)
[21]         i:pd(o)           q:interm(o,s)
[22]         i:pf(f)           q:factor(f,s)       p:bpf(f,s)
[23]       +  a:gov     t:btf(f,s)     va:
[24]       
[25]       $prod:u             s:esubc
[26]         o:pu              q:(sum(o, demand(o)))
[27]         i:pd(o)           q:demand(o)
[28]       
[29]       $prod:g
[30]         o:pg              q:(sum(o, govdem(o)))
[31]         i:pd(o)           q:govdem(o)
[32]       
[33]       $demand:ra
[34]         d:pu
[35]         e:pf(f)           q:endow(f)
[36]       
[37]       $demand:gov
[38]         d:pg
 $offtext

*   Alert the user to undefined sets or parameters which are referenced in the MPSGE model:

$if not settype s          $abort "s should be a SET."
$if not settype o          $abort "o should be a SET."
$if not settype f          $abort "f should be a SET."
$if not partype supply     $abort "supply should be a PARAMETER."
$if not dimension 2 supply $abort "supply has an inconsistent dimension."
$if not partype bto        $abort "bto should be a PARAMETER."
$if not dimension 2 bto    $abort "bto has an inconsistent dimension."
$if not partype interm     $abort "interm should be a PARAMETER."
$if not dimension 2 interm $abort "interm has an inconsistent dimension."
$if not partype factor     $abort "factor should be a PARAMETER."
$if not dimension 2 factor $abort "factor has an inconsistent dimension."
$if not partype bpf        $abort "bpf should be a PARAMETER."
$if not dimension 2 bpf    $abort "bpf has an inconsistent dimension."
$if not partype btf        $abort "btf should be a PARAMETER."
$if not dimension 2 btf    $abort "btf has an inconsistent dimension."
$if not partype demand     $abort "demand should be a PARAMETER."
$if not dimension 1 demand $abort "demand has an inconsistent dimension."
$if not partype govdem     $abort "govdem should be a PARAMETER."
$if not dimension 1 govdem $abort "govdem has an inconsistent dimension."
$if not partype endow      $abort "endow should be a PARAMETER."
$if not dimension 1 endow  $abort "endow has an inconsistent dimension."

*    Define aliases for sets:

alias (s,s_); 
alias (o,o_); 
alias (f,f_); 

*    Benchmark costs and value shares:

PARAMETER

*    Benchmark costs:

        c0_002(s,o) Benchmark cost for input pd(o) in sector y(s)
        c0_004(s,f) Benchmark cost for input pf(f) in sector y(s)
        c0_003(s)   Benchmark cost for input nest va in sector y(s)
        c0_001(s)   Benchmark cost for input nest s in sector y(s)
        c0_008(o)   Benchmark cost for input pd(o) in sector u
        c0_007      Benchmark cost for input nest s in sector u
        c0_012(o)   Benchmark cost for input pd(o) in sector g
        c0_011      Benchmark cost for input nest s in sector g

*    Benchmark revenue:

        r0_006(s,o) Benchmark revenue for output pd(o) in sector y(s)
        r0_005(s)   Benchmark revenue for output nest t in sector y(s)
        r0_010      Benchmark revenue for output pu in sector u
        r0_009      Benchmark revenue for output nest t in sector u
        r0_014      Benchmark revenue for output pg in sector g
        r0_013      Benchmark revenue for output nest t in sector g

*    Benchmark shares:

        theta_004(s,f) Benchmark share for input  pf(f) in nest va for sector y(s)
        theta_002(s,o) Benchmark share for input  pd(o) in nest s for sector y(s)
        theta_003(s)   Benchmark share for input nest  va in nest s for sector y(s)
        theta_006(s,o) Benchmark share for output pd(o) in nest t for sector y(s)
        theta_008(o)   Benchmark share for input  pd(o) in nest s for sector u
        theta_010      Benchmark share for output pu in nest t for sector u
        theta_012(o)   Benchmark share for input  pd(o) in nest s for sector g
        theta_014      Benchmark share for output pg in nest t for sector g
;



*   Invoke the function preprocessor


$sysinclude gams-f

c0_002(s,o) = interm(o,s);                   
c0_004(s,f) = (factor(f,s))*(bpf(f,s));      
r0_006(s,o) = supply(s,o);                   
c0_003(s) = +sum(f,c0_004(s,f));             
c0_001(s) = +sum(o,c0_002(s,o)) + c0_003(s); 
r0_005(s) = +sum(o,r0_006(s,o));             
c0_008(o) = demand(o);                       
r0_010 = (sum(o, demand(o)));                
c0_007 = +sum(o,c0_008(o));                  
r0_009 = +r0_010;                            
c0_012(o) = govdem(o);                       
r0_014 = (sum(o, govdem(o)));                
c0_011 = +sum(o,c0_012(o));                  
r0_013 = +r0_014;                            
theta_004(s,f) = c0_004(s,f)/c0_003(s); 
theta_002(s,o) = c0_002(s,o)/c0_001(s); 
theta_003(s) = c0_003(s)/c0_001(s);     
theta_006(s,o) = r0_006(s,o)/r0_005(s); 
theta_008(o) = c0_008(o)/c0_007;        
theta_010 = r0_010/r0_009;              
theta_012(o) = c0_012(o)/c0_011;        
theta_014 = r0_014/r0_013;              

*   Cost functions

p_002(s,o) == pd(o);                                                                                                                                                                              
p_004(s,f) == pf(f) * (1+btf(f,s))/(bpf(f,s));                                                                                                                                                    
p_006(s,o) == pd(o) * (1+bto(s,o));                                                                                                                                                               
p_003(s) ==( sum(f,theta_004(s,f) * p_004(s,f)))$(esub(s)=0) + ( sum(f,theta_004(s,f) * p_004(s,f)**(1-esub(s)))$(esub(s)<>1 and esub(s)<>0 ) + ( prod(f,p_004(s,f)**theta_004(s,f))$(esub(s)=1); 
p_001(s) == sum(o,theta_002(s,o) * p_002(s,o))+theta_003(s)*p_003(s);                                                                                                                             
p_005(s) ==( sum(o,theta_006(s,o) * p_006(s,o)))$(etrn(s)=0) + ( sum(o,theta_006(s,o) * p_006(s,o)**(1-etrn(s)))$(etrn(s)<>1 and etrn(s)<>0 ) + ( prod(o,p_006(s,o)**theta_006(s,o))$(etrn(s)=1); 
p_008(o) == pd(o);                                                                                                                                                                                
p_010 == pu;                                                                                                                                                                                      
p_007 ==( sum(o,theta_008(o) * p_008(o)))$(esubc=0) + ( sum(o,theta_008(o) * p_008(o)**(1-esubc))$(esubc<>1 and esubc<>0 ) + ( prod(o,p_008(o)**theta_008(o))$(esubc=1);                          
p_009 == theta_010*p_010;                                                                                                                                                                         
p_012(o) == pd(o);                                                                                                                                                                                
p_014 == pg;                                                                                                                                                                                      
p_011 == sum(o,theta_012(o) * p_012(o));                                                                                                                                                          
p_013 == theta_014*p_014;                                                                                                                                                                         

*   Quantity functions

q_002(s,o) == interm(o,s);    
q_004(s,f) == factor(f,s);    
q_006(s,o) == supply(s,o);    
q_008(o) == demand(o);        
q_010 == (sum(o, demand(o))); 
q_012(o) == govdem(o);        
q_014 == (sum(o, govdem(o))); 

*   Compensated demand indices:

d_001(s) ==  1;                                         
d_002(s,o) == d_001(s)* (p_001(s)/p_002(s,o))**0;       
d_003(s) == d_001(s)* (p_001(s)/p_003(s))**0;           
d_004(s,f) == d_003(s)* (p_003(s)/p_004(s,f))**esub(s); 
d_007 ==  1;                                            
d_008(o) == d_007* (p_007/p_008(o))**esubc;             
d_011 ==  1;                                            
d_012(o) == d_011* (p_011/p_012(o))**0;                 

*   Compensated supply indices:

s_005(s) ==  1;                                         
s_006(s,o) == s_005(s)* (p_005(s)/p_006(s,o))**etrn(s); 
s_009 ==  1;                                            
s_010 == s_009* (p_009/p_010)**0;                       
s_013 ==  1;                                            
s_014 == s_013* (p_013/p_014)**0;                       

*   Endowments:

e_015(f) == endow(f); 


POSITIVE VARIABLES
        y(s)  production
        u     utility index
        g     government expenditure
        pd(o) domestic price of commodity
        pf(f) price of primary factor
        pu    price index for utility
        pg    price of a government output unit
        ra    representative agent income
        gov   government income;


EQUATIONS
        prf_y(s)  "production"
        prf_u     "utility index"
        prf_g     "government expenditure"
        mkt_pd(o) "domestic price of commodity"
        mkt_pf(f) "price of primary factor"
        mkt_pu    "price index for utility"
        mkt_pg    "price of a government output unit"
        inc_ra    "representative agent income"
        inc_gov   "government income";



MODEL taxout / prf_y.y,prf_u.u,prf_g.g,mkt_pd.pd,mkt_pf.pf,mkt_pu.pu,mkt_pg.pg,inc_ra.ra,inc_gov.gov/; 

*     Level value assignments
y.l(s) = 1;  
u.l = 1;     
g.l = 1;     
pd.l(o) = 1; 
pf.l(f) = 1; 
pu.l = 1;    
pg.l = 1;    

*     Zero profit conditions
prf_y(s).. c0_001(s)*p_001(s) =G= r0_005(s)*p_005(s);
prf_u..    c0_007*p_007 =G= r0_009*p_009;
prf_g..    c0_011*p_011 =G= r0_013*p_013;

*     Market clearance conditions
mkt_pd(o).. 
            +sum(s,s_006(s,o)*y(s)*q_006(s,o))+sum(s,-d_002(s,o)*y(s)*q_002(s,o))-d_008(o)*u*q_008(o)-d_012(o)*g*q_012(o) =e= 0;
mkt_pf(f).. 
            +sum(s,-d_004(s,f)*y(s)*q_004(s,f)) + e_015(f) =e= 0;
mkt_pu..    
            s_010*u*q_010-ra/pu =e= 0;
mkt_pg..    
            s_014*g*q_014-gov/pg =e= 0;

*     Income definitions
inc_ra..  
          ra =e=+sum((f,pf(f)*endow(f));
inc_gov.. 
          gov =e=
          +sum((s,o),bto(s,o)*s_006(s,o)*y(s)*pd(o))
          +sum((s,f),btf(f,s)*d_004(s,f)*y(s)*pf(f));

*     Auxiliary constraints:
